Package org.codehaus.groovy.macro.runtime

# Enum MacroBuilder

java.lang.Object
java.lang.Enum<MacroBuilder>
org.codehaus.groovy.macro.runtime.MacroBuilder

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<MacroBuilder>`, `java.lang.constant.Constable`

    @Incubating
    public enum MacroBuilder
    extends java.lang.Enum<MacroBuilder>

Runtime support for

    macro {}

method.

Since:
  2.5.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `java.lang.Enum.EnumDesc<E extends java.lang.Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant | Description
  --- | ---
  `INSTANCE` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static ASTNode` | `getMacroValue​(BlockStatement closureBlock, boolean asIs)` |
  `<T> T` | `macro​(boolean asIs, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)` |
  `<T> T` | `macro​(java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)` |
  `<T> T` | `macro​(CompilePhase compilePhase, boolean asIs, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)` |
  `<T> T` | `macro​(CompilePhase compilePhase, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)` |
  `static MacroBuilder` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
  `static MacroBuilder[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### INSTANCE

    public static final MacroBuilder INSTANCE

- ## Method Details

  - ### values

    public static MacroBuilder[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static MacroBuilder valueOf​(java.lang.String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
      `java.lang.NullPointerException` - if the argument is null

  - ### macro

    public <T> T macro​(java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)

  - ### macro

    public <T> T macro​(boolean asIs, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)

  - ### macro

    public <T> T macro​(CompilePhase compilePhase, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)

  - ### macro

    public <T> T macro​(CompilePhase compilePhase, boolean asIs, java.lang.String source, java.util.List<Closure<Expression>> context, java.lang.Class<T> resultClass)

  - ### getMacroValue

    public static ASTNode getMacroValue​(BlockStatement closureBlock, boolean asIs)